{$MODE objfpc}
uses gl,glu,glext,SysUtils,sdl;
const
  ScreenWidth = 640;
  ScreenHeight = 480;
  BitsPerPixel = 16;
      BigDiskRadius=5.0;
      LittleDiskRadius=2.0;
      InnerRadius=1.0;
      DiskHeight=1;
      DistDisks=0.1;
      PlusBarHeight=0.5;
      BarRadius=0.9;
      BarDist=11.0;
      Add=0.8;
      N=7;

var
  surface : PSDL_Surface;
  q:pGLUquadricObj;
  tr,rotdx,rotdy,rotdz:real;
var DiskData:array[1..3,0..20] of byte;
  FlyIngIndex:integer;
  FlyHeight,FlyPosition:GLFloat;
procedure DrawDisk(n,index:integer);
const
      ambdiff:array[0..7] of GLFloat=(0.0,0.5,0.6,1,  0.3,0.7,0.6,1);
      specularobj:array[0..3] of GLFloat=(0.7,0.7,0.7,1);
      shininessobj:GLFloat=60;
var Radius,Scale:GLFloat;
    ambanddiffobj:array[0..3] of GLFloat;
    var i:integer;
begin
     Scale:=(index-1)/(n-1);
     for i:=0 to 3 do begin ambanddiffobj[i]:=(ambdiff[i]*scale)+ambdiff[i+4]*(1-scale) end;
     glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ambanddiffobj);
     glMaterialfv(GL_FRONT,GL_SPECULAR,specularobj);
     glMaterialf(GL_FRONT,GL_SHININESS,shininessobj);
     glPushMatrix;
     Radius:=LittleDiskRadius+(BigDiskRadius-LittleDiskRadius)*Scale;
     glRotatef(-90,1,0,0);
     gluCylinder(q,InnerRadius,Radius,0,16,3);
     gluCylinder(q,Radius,Radius,DiskHeight,16,3);
     glFrontFace(GL_CW);
     gluCylinder(q,InnerRadius,InnerRadius,DiskHeight,16,3);
     glFrontFace(GL_CCW);
     glTranslatef(0,0,DiskHeight);
     gluCylinder(q,Radius,InnerRadius,0,16,3);
     glPopMatrix
end;
procedure DrawBar(n:integer);
const
      ambanddiffobj:array[0..3] of GLFloat=(0.5,0.5,0.6,1);
      specularobj:array[0..3] of GLFloat=(1,1,1,1);
      shininessobj:GLFloat=60;
var Height:GLFloat;
begin
     glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ambanddiffobj);
     glMaterialfv(GL_FRONT,GL_SPECULAR,specularobj);
     glMaterialf(GL_FRONT,GL_SHININESS,shininessobj);
     glPushMatrix;
     Height:=n*(DiskHeight+DistDisks)+PlusBarHeight;
     glRotatef(-90,1,0,0);
     gluCylinder(q,BarRadius,BarRadius,Height,8,8);
     glTranslatef(0,0,Height);
     gluSphere(q,BarRadius,8,8);
     glPopMatrix
end;
procedure DrawFace(x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4:real);
begin
     glTexCoord2f(0,0);
     glVertex3f(x1,y1,z1);
     glTexCoord2f(0,1);
     glVertex3f(x2,y2,z2);
     glTexCoord2f(1,1);
     glVertex3f(x3,y3,z3);
     glTexCoord2f(1,0);
     glVertex3f(x4,y4,z4)
end;
procedure DrawABox(ax,ay,az,bx,by,bz:real);
begin
     glBegin(GL_QUADS); //Normalvektorok kellenek a fenyhatasokhoz
       glNormal3f( 0, 0, 1); DrawFace(Ax,Bx,Bx,Ax, Ay,Ay,By,By, Bz,Bz,Bz,Bz);
       glNormal3f( 0, 0,-1); DrawFace(Ax,Bx,Bx,Ax, By,By,Ay,Ay ,Az,Az,Az,Az);
       glNormal3f( 0,-1, 0); DrawFace(Ax,Bx,Bx,Ax, Ay,Ay,Ay,Ay ,Az,Az,Bz,Bz);
       glNormal3f( 0, 1, 0); DrawFace(Ax,Ax,Bx,Bx, By,By,By,By ,Az,Bz,Bz,Az);
       glNormal3f(-1, 0, 0); DrawFace(Ax,Ax,Ax,Ax, Ay,Ay,By,By ,Az,Bz,Bz,Az);
       glNormal3f( 1, 0, 0); DrawFace(Bx,Bx,Bx,Bx, Ay,By,By,Ay ,Az,Az,Bz,Bz);
     glEnd
end;
procedure DrawColumn(n,I:Integer);
var II:Integer;
begin
     glPushMatrix;
     glTranslatef(Bardist/2+BarDist*(i-1),0,Bardist/2);
     DrawBar(n);
     glTranslatef(0,DistDisks,0);
     for II:=1 to DiskData[I,0] do begin
         DrawDisk(n,DiskData[i,ii]);
         glTranslatef(0,DiskHeight+DistDisks,0);
     end;
     glPopMatrix
end;
procedure DrawScene;
const
      ambanddiffobj:array[0..3] of GLFloat=(0.6,0.4,0.0,1);
      specularobj:array[0..3] of GLFloat=(0.7,0.7,0.7,1);
      shininessobj:GLFloat=60;

begin
     glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ambanddiffobj);
     glMaterialfv(GL_FRONT,GL_SPECULAR,specularobj);
     glMaterialf(GL_FRONT,GL_SHININESS,shininessobj);
     DrawABox(0,-0.5,0,BarDist*3,0,BarDist);
     DrawColumn(n,1);DrawColumn(n,2);DrawColumn(n,3);
     if Flyingindex<>0 then begin
        glPushMatrix;
        glTranslatef(Bardist/2+BarDist*(FlyPosition-1),FlyHeight,Bardist/2);
        DrawDisk(n,FlyIngIndex);
        glPopMatrix
     end;
end;
procedure TerminateApplication;
begin
  SDL_QUIT;
  Halt(0);
end;
function ResizeWindow( width : integer; height : integer ) : Boolean;
begin
  if height = 0 then height := 1;
  glViewport( 0, 0, width, height );
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity;
  gluPerspective( 45.0, width / height, 0.1, 100.0 );
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity;
  result := true;
end;
procedure HandleKeyPress( keysym : PSDL_keysym );
begin
  case keysym^.sym of
    SDLK_ESCAPE :
      TerminateApplication;
    SDLK_F1 :
      SDL_WM_ToggleFullScreen( surface );
  end;
end;
procedure InitGL;
const gambient:array[0..3] of GLFloat=(0.3,0.3,0.3,1.0);
      LDiffuseAndSpecular:array[0..3] of GLFloat=(1.0,1.0,1.0,1.0);
      LAmbient:array[0..3] of GLFloat=(0,0,0,1);
begin
  glShadeModel( GL_SMOOTH ); //Smooth shadeing
  glClearColor(0,0,0,0); //Hatter szin
  glClearDepth(1);
  glEnable( GL_DEPTH_TEST ); //Depth Buffer Beinditasa
  glDepthFunc( GL_LESS);
  glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST ); //Szebben nez ki, de lassabb
  glEnable(GL_LIGHTING); //Fenyek Beinditasa
  glEnable(GL_LIGHT0); //Feny 0 bekapcsolasa

  glLightfv(GL_LIGHT0,GL_DIFFUSE,LDiffuseAndSpecular);
  glLightfv(GL_LIGHT0,GL_SPECULAR,LDiffuseAndSpecular);
  glLightfv(GL_LIGHT0,GL_AMBIENT,LAmbient);

  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE); //Csak a Front face-eket szamolja
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT,gambient); //Altalanos "Ambient" feny
//  glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE); //Lasabb, de szebb, valosaghubb
  glEnable(GL_CULL_FACE); //Az egyik oldalt ki se kell rajzolni
  glCullFace(GL_BACK); //Az az oldal ami nem lesz ki rajzolva az a hatso oldal
  q:=gluNewQuadric(); //Hengerhez es Gombhoz kell
  gluQuadricNormals(q,GLU_SMOOTH);
  gluQuadricTexture(q,GL_TRUE);
end;
procedure DrawGLScene;
const lightpos:array[0..3] of GLFloat =(0,0,0,1);//(1,0,1,0);
var i:integer;
begin
  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );
  glLoadIdentity();
  glLightfv(GL_LIGHT0,GL_POSITION,lightpos); //A feny a szemlelo helyen van
  glTranslatef(0.0,0.0,-40+tr); //Kihozzuk a kamerat
  glRotatef(rotdx,1,0,0);
  glRotatef(rotdy,0,1,0);
  glRotatef(rotdz,0,0,1);
  glTranslatef(-BarDist*3/2,0,-BarDist/2);
  DrawScene;
  SDL_GL_SwapBuffers; //Double Buffering-hez kell
end;
var event : TSDL_Event;
    videoflags : Uint32;
    keystate: PKeyStateArr;
    Done : Boolean;
procedure DoEvents;
begin
    while (SDL_PollEvent(@event)=1) do
      case event.type_ of
        SDL_QUITEV : TerminateApplication; //Done := true;
        SDL_KEYDOWN : HandleKeyPress( @event.key.keysym );
        SDL_VIDEORESIZE :
        begin
          surface := SDL_SetVideoMode( event.resize.w, event.resize.h, BitsPerPixel, videoflags );
          InitGL;
          ResizeWindow( event.resize.w, event.resize.h );
        end
      end;
    keystate := PKeyStateArr(SDL_GetKeyState(nil));
    if keystate^[SDLK_DOWN]<>0 then rotdx:=rotdx+1;
    if keystate^[SDLK_UP]<>0 then rotdx:=rotdx-1;
    if keystate^[SDLK_Left]<>0 then rotdy:=rotdy+1;
    if keystate^[SDLK_Right]<>0 then rotdy:=rotdy-1;
    if keystate^[SDLK_A]<>0 then tr:=tr-0.5;
    if keystate^[SDLK_Q]<>0 then tr:=tr+0.5;
    DrawGLScene;
end;
procedure AnimateFly(Index,F,T:Integer);
var Height:GLFloat;
begin
     Height:=n*(DiskHeight+DistDisks)+PlusBarHeight+BarRadius+DiskHeight;
     FlyIngIndex:=Index;
     FlyPosition:=F;
     FlyHeight:=(DiskHeight+DistDisks)*DiskData[F,0]+DistDisks;
     while FlyHeight<Height do begin
           DoEvents;
           FlyHeight:=FlyHeight+Add
     end;
     FlyHeight:=Height;
     if F<T then
        while FlyPosition<t do begin
              DoEvents;
              FlyPosition:=FlyPosition+Add/BarDist
        end
     else
        while FlyPosition>t do begin
              DoEvents;
              FlyPosition:=FlyPosition-Add/BarDist
        end;
     FlyPosition:=T;
     Height:=(DiskHeight+DistDisks)*DiskData[T,0]+DistDisks;
     While FlyHeight>Height do begin
           DoEvents;
           FlyHeight:=FlyHeight-Add
     end;
     FlyingIndex:=0
end;
procedure Hanoi(F,T,H:Integer);
var Index:Integer;
begin
     if h=1 then begin
        Index:=DiskData[F,DiskData[F,0]];
        Dec(DiskData[F,0]);
        AnimateFly(Index,F,T);
        Inc(DiskData[T,0]);
        DiskData[T,DiskData[t,0]]:=Index;
     end else begin
         Hanoi(F,6-F-T,H-1);
         Hanoi(F,T,1);
         Hanoi(6-F-T,T,H-1)
     end
end;
var I:Integer;
begin
  For I:=1 to n do DiskData[1,i]:=n-i+1; FlyingIndex:=0;
  DiskData[1,0]:=n;
  DiskData[2,0]:=0;
  DiskData[3,0]:=0;  tr:=0;
  SDL_Init(SDL_INIT_VIDEO);
  videoFlags := SDL_OPENGL or SDL_DOUBLEBUF or SDL_HWPALETTE or SDL_RESIZABLE;
  with SDL_GetVideoInfo^ do begin
       if hw_available<>0 then videoFlags := videoFlags or SDL_HWSURFACE
       else videoFlags := videoFlags or SDL_SWSURFACE;
       if blit_hw<>0 then videoFlags := videoFlags or SDL_HWACCEL
  end;
  SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
  SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
  SDL_WM_SetCaption('Jatek',nil);
  surface := SDL_SetVideoMode( ScreenWidth, ScreenHeight, BitsPerPixel, videoflags );
  InitGL;
  ReSizeWindow( ScreenWidth, ScreenHeight );
  Hanoi(1,2,n);
  Done := False;
  while ( not Done ) do begin
        DoEvents;
  end;
  TerminateApplication;
end.
